Unit ID24R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII12_p;

procedure ID24R(var P :Integer; var Q :Integer; N1 :Integer;
                M1 :Integer; M2 :Integer; H1 :Real; H2 :Real;
                A1 :Real; A2 :Real; X :Real; Y :Real;
                var F :Array of Real; var S :Real; var IERR :Integer);

implementation

procedure ID24R(var P :Integer; var Q :Integer; N1 :Integer;
                M1 :Integer; M2 :Integer; H1 :Real; H2 :Real;
                A1 :Real; A2 :Real; X :Real; Y :Real;
                var F :Array of Real; var S :Real; var IERR :Integer);
var
I,I1,IL,J,J1,J2,J3,J4,K,K1,L,L1,ML1,ML2,N,N3,NL1,NL2 :Integer;
TX,TY,V1,V2,XM,XN,XX,YM,YN,YY :Real;
B :Array [0..7] of Real;
C :Array [0..7] of Real;
D :Array [0..3] of Real;
R1 :Array [0..7] of Real;
R2 :Array [0..7] of Real;
RR :Array [0..1] of Real;
T1 :Array [0..7] of Real;
T2 :Array [0..7] of Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,
_440;
begin
if ( (X - A1)*(A1 + (M1 - 1)*H1 - X) ) < 0
 then goto _390
 else if ( (X - A1)*(A1 + (M1 - 1)*H1 - X) ) > 0
       then goto _10
       else goto _10;
_10:
if ( (Y - A2)*(A2 + (M2 - 1)*H2 - Y) ) < 0
 then goto _390
 else if ( (Y - A2)*(A2 + (M2 - 1)*H2 - Y) ) > 0
       then goto _20
       else goto _20;
_20:
N  := Trunc( N1/2 + 0.1 );
NL1  := 0;
ML1  := 0;
NL2  := 0;
ML2  := 0;
XX  := X;
YY  := Y;
IL  := 0;
K  := Trunc( (X - A1)/H1 + 1 + 0.1E-10 );
L  := Trunc( (Y - A2)/H2 + 1 + 0.1E-10 );
L1  := L;
K1  := K;
XN  := A1 + (N - 1)*H1;
XM  := A1 + (M1 - N - 1)*H1;
YN  := A2 + (N - 1)*H2;
YM  := A2 + (M2 - N - 1)*H2;
_30:
C[IL+3] := S;
if ( K1 - N ) < 0
 then goto _40
 else if ( K1 - N ) > 0
       then goto _50
       else goto _50;
_40:
X  := XN;
K  := N;
NL1  := NL1 + 1;
P  := P + NL1 - 1;
TX  := XN;
_50:
if ( L1 - N ) < 0
 then goto _60
 else if ( L1 - N ) > 0
       then goto _70
       else goto _70;
_60:
Y  := YN;
L  := N;
NL2  := NL2 + 1;
Q  := Q + NL2 - 1;
TY  := YN;
_70:
if ( K1 - M1 + N ) < 0
 then goto _90
 else if ( K1 - M1 + N ) > 0
       then goto _80
       else goto _90;
_80:
X  := XM;
K  := M1 - N;
ML1  := ML1 + 1;
P  := P + ML1 - 1;
TX  := XM;
_90:
if ( L1 - M2 + N ) < 0
 then goto _110
 else if ( L1 - M2 + N ) > 0
       then goto _100
       else goto _110;
_100:
Y  := YM;
L  := M2 - N;
ML2  := ML2 + 1;
Q  := Q + ML2 - 1;
TY  := YM;
_110:
N3  := N + 1;
B[0] := 1;
if ( P + Q - 2 ) < 0
 then goto _140
 else if ( P + Q - 2 ) > 0
       then goto _120
       else goto _140;
_120:
for I:=2 to N1 do
 begin
  B[I-1] := B[I-2]*(N1 - I + 1);
_130:
 end;
_140:
for I:=1 to N do
 begin
  T1[I-1] := X - A1 - (K - N + I - 1)*H1;
  if ( N1 - P ) < 0
   then goto _410
   else if ( N1 - P ) > 0
         then goto _160
         else goto _150;
_150:
  T1[I-1] := B[P-1];
  goto _170;
_160:
  T1[I-1] := B[P-1]*Power(T1[I-1]/H1,N1 - P);
  T2[I-1] := Y - A2 - (L - N + I - 1)*H2;
_170:
  if ( N1 - Q ) < 0
   then goto _420
   else if ( N1 - Q ) > 0
         then goto _190
         else goto _180;
_180:
  T2[I-1] := B[Q-1];
  goto _200;
_190:
  T2[I-1] := B[Q-1]*Power(T2[I-1]/H2,N1 - Q);
 end;
_200:
for I:=N3 to N1 do
 begin
  T1[I-1] := A1 + (K - N + I - 1)*H1 - X;
  if ( N1 - P ) < 0
   then goto _410
   else if ( N1 - P ) > 0
         then goto _220
         else goto _210;
_210:
  T1[I-1] := B[P-1];
  goto _230;
_220:
  T1[I-1] := B[P-1]*Power(T1[I-1]/H1,N1 - P);
  T2[I-1] := A2 + (L - N + I - 1)*H2 - Y;
_230:
  if ( N1 - Q ) < 0
   then goto _420
   else if ( N1 - Q ) > 0
         then goto _250
         else goto _240;
_240:
  T2[I-1] := B[Q-1];
  goto _260;
_250:
  T2[I-1] := B[Q-1]*Power(T2[I-1]/H2,N1 - Q);
 end;
_260:
D[0] := 1;
D[1] := -N1;
D[2] := (N1 - 1)*N;
D[3] := -56;
C[0] := 1;
C[1] := 4;
C[2] := 66;
C[3] := 2416;
RR[0] := C[N-1]*Power(H1,P - 1);
RR[1] := C[N-1]*Power(H2,Q - 1);
if ( (RR[0] <=  0.0) ) or (  (RR[1] <=  0.0) ) 
 then goto _400;
for I:=1 to N do
 begin
  I1  := N1 - I + 1;
  V1  := 0;
  V2  := 0;
  for J:=1 to I do
   begin
    J1  := N - J + 1;
    J2  := I - J + 1;
    V1  := V1 + D[J2-1]*T1[J1-1];
    V2  := V2 + D[J2-1]*T2[J1-1];
_270:
   end;
  R1[I1-1] := V1/RR[0];
  R2[I1-1] := V2/RR[1];
_280:
 end;
for I:=1 to N do
 begin
  V1  := 0;
  V2  := 0;
  for J:=1 to I do
   begin
    J3  := J + N;
    J4  := I - J + 1;
    V1  := V1 + D[J4-1]*T1[J3-1];
    V2  := V2 + D[J4-1]*T2[J3-1];
_290:
   end;
  R1[I-1] := Power(-1,P + 1)*V1/RR[0];
  R2[I-1] := Power(-1,Q + 1)*V2/RR[1];
_300:
 end;
S  := 0;
for I:=1 to N1 do
 begin
  I1  := K - N + I;
  for J:=1 to N1 do
   begin
    J1  := L - N + J;
    S  := S + F[(I1-1)+(J1-1)*M1]*R1[I-1]*R2[J-1];
_310:
   end;
_320:
 end;
C[0] := 1;
C[1] := 4.0/9.0;
C[2] := IntPower(11.0/20.0,2);
C[3] := IntPower(151.0/315.0,2);
S  := C[N-1]*S;
if ( IL  =  1 ) 
 then goto _330;
if ( IL  =  2 ) 
 then goto _340;
if ( IL  =  3 )
 then goto _370;
if ( IL  =  4 ) 
 then goto _380;
if ( (NL1  =  1 ) or (  ML1  =  1) ) and ( 
     (NL2  =  1 ) or (  ML2  =  1 )) 
 then goto _330;
if ( (NL1  =  1 ) or (  ML1  =  1) ) or ( 
     (NL2  =  1 ) or (  ML2  =  1 )) 
 then goto _350;
goto _440;
_330:
IL  := IL + 1;
NL2  := NL2 - 1;
ML2  := ML2 - 1;
if ( IL  =  1 ) 
 then goto _30;
NL1  := NL1 - 2;
ML1  := ML1 - 2;
NL2  := NL2 + 1;
ML2  := ML2 + 1;
goto _30;
_340:
S  := C[4] + C[5]*(XX - TX) + S*(YY - TY);
goto _440;
_350:
if ( NL1  =  1 ) or (  ML1  =  1 ) 
 then goto _360;
IL  := 3;
goto _30;
_360:
IL  := 4;
goto _30;
_370:
S  := C[6] + S*(YY - TY);
goto _440;
_380:
S  := C[7] + S*(XX - TX);
goto _440;
_390:
IERR  := 2;
goto _430;
_400:
IERR  := 1;
goto _430;
_410:
IERR  := 3;
goto _430;
_420:
IERR  := 4;
goto _430;
_430:
if ( IERR  <>  0 ) 
 then UTII12(IERR,3);
_440:
end;

end.
